//Iterration example for the PIC target

#pragma CLOCK_FREQ 4000000

#define MAX_ITER_COUNT 6

char iter_count;
char iter_val[MAX_ITER_COUNT];

void iter( void )
{
    if( iter_count++ >= MAX_ITER_COUNT )
        return;
    iter_val[iter_count-1] = 1;
    iter();
}

main()
{
    char i, sum = 0;

    //Hardware Initialization
    disable_interrupt( GIE );
    //disable_interrupt( 7 );
    set_bit( STATUS, RP0 );
    //set_bit( 3, 5 );
    set_tris_b( 0 );
    clear_bit( STATUS, RP0 );
    //clear_bit( 3, 5 );
    output_port_b( 0 );

    iter_count = 0;
    for( i = 0; i < MAX_ITER_COUNT; i++ )
        iter_val[i] = 0;

    iter();

    //check the result
    for( i = 0; i < MAX_ITER_COUNT; i++ )
        sum = sum + iter_val[i];
    if( sum != MAX_ITER_COUNT )
        output_high_port_b( 0 );

    while( 1 )
    {
        output_low_port_b( 7 );
        delay_ms( 250 );
        output_high_port_b( 7 );
        delay_ms( 250 );
    }
}
