//Interrupt example for the SX target

//This variable will be incremented in every
//interrupt call and written into the PORTB
char portState = 0;
char extraDivider = 0; //some extra divider because SX runs so fast :)

void interrupt( void )
{   
    extraDivider++;
    if( extraDivider == 0 )
        output_port_b( portState++ );
}

void main( void )
{
    //Hardware Initialization
    set_tris_b( ~15 );
    output_port_b( portState );
    
    set_option( 135 ); //set divider 1:256
    
    //Start endless loop
    while( 1 );
}
